"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var tools_1 = require("./lib/tools");
function StickyScrollSpyNav(_a) {
    var header = _a.header, nav = _a.nav, children = _a.children, navContainerStyle = _a.navContainerStyle, navItemStyle = _a.navItemStyle;
    var navEl = (0, react_1.useRef)(null);
    var _b = (0, react_1.useState)(0), navHeight = _b[0], setNavHeight = _b[1];
    var onScroll = (0, tools_1.throttle)(function () {
        var _a, _b, _c, _d, _e, _f;
        var scrollElement = document.scrollingElement || document.documentElement;
        var outerHeight = window.innerHeight;
        var scrollTop = scrollElement.scrollTop;
        var scrollHeight = scrollElement.scrollHeight;
        var firstEl = (_b = (_a = children[0]) === null || _a === void 0 ? void 0 : _a.ref) === null || _b === void 0 ? void 0 : _b.current;
        var isNotStart = firstEl && firstEl.offsetTop > scrollTop;
        var isEnd = scrollTop + outerHeight >= scrollHeight;
        if (isNotStart) {
            firstEl.classList.add("active");
        }
        else if (isEnd) {
            var lastEl = (_d = (_c = children[children.length - 1]) === null || _c === void 0 ? void 0 : _c.ref) === null || _d === void 0 ? void 0 : _d.current;
            var lastBoforeEl = (_f = (_e = children[children.length - 2]) === null || _e === void 0 ? void 0 : _e.ref) === null || _f === void 0 ? void 0 : _f.current;
            if (lastEl && lastBoforeEl) {
                lastEl.classList.add("active");
                lastBoforeEl.classList.remove("active");
            }
        }
        else {
            children.forEach(function (el) {
                var _a;
                var target = (_a = el === null || el === void 0 ? void 0 : el.ref) === null || _a === void 0 ? void 0 : _a.current;
                if (target) {
                    var visibleVertical = target.offsetTop >= 0 &&
                        scrollElement.scrollTop + navHeight >= target.offsetTop &&
                        scrollElement.scrollTop + navHeight < target.offsetTop + target.offsetHeight;
                    if (visibleVertical) {
                        target.classList.add("active");
                    }
                    else {
                        target.classList.remove("active");
                    }
                }
            });
        }
    });
    var handleClick = function (index) {
        var _a, _b;
        var offsetTop = ((_b = (_a = children[index]) === null || _a === void 0 ? void 0 : _a.ref) === null || _b === void 0 ? void 0 : _b.current.offsetTop) || 0;
        window.scrollTo({ top: offsetTop - navHeight, behavior: "smooth" });
    };
    (0, react_1.useEffect)(function () {
        var _a;
        setNavHeight(((_a = navEl === null || navEl === void 0 ? void 0 : navEl.current) === null || _a === void 0 ? void 0 : _a.clientHeight) || 0);
        window.addEventListener("scroll", onScroll);
        return function () {
            window.removeEventListener("scroll", onScroll);
        };
    }, [onScroll]);
    return (react_1.default.createElement("div", null,
        header,
        react_1.default.createElement("nav", { ref: navEl, style: __assign({ position: "sticky", top: 0 }, navContainerStyle) }, nav.map(function (navName, i) { return (react_1.default.createElement("button", { onClick: function () { return handleClick(i); }, key: "" + navName + i, style: navItemStyle }, navName)); })),
        children));
}
exports.default = StickyScrollSpyNav;
//# sourceMappingURL=StickyScrollSpyNav.js.map